#
#  Vispan - Virus and Spam analyser
#  This program analyses the mail log file entries created by the 
#  MailScanner program written by Julian Field. It is available at
#  http://www.mailscanner.info
#
# Copyright (C) 2002 David While
#
# $Id: Postfix.pm,v 1.2 2004/09/27 16:04:24 dwhile Exp $
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
# The author, David While, can be contacted by email at
# david.while@uce.ac.uk
# or by paper mail at
# David While
# School of Computing
# University of Central England
# Birmingham
# B42 2SU
# United Kingdom
#

package Postfix;

my $Delay = 0;

##################################################
#                                                #
# Subroutine: ProcessLine                        #
# Parameters: Postfix Log entry                  #
# Returns: None                                  #
# Purpose: Process a Postfix log entry           #
#                                                #
##################################################
sub ProcessLine {
   my($Line) = @_;

   my( $Size, $Day, $Hour, $Min, $Sec );

   SWITCH: {

      # We have rejected the mail for some reason
      ( $Line =~ /reject/ ) && do {
         Stats::AddReject;
         last SWITCH;
         };

      # Add message delay time in seconds.
      ( $Line =~ /status=sent/ ) && do {
         ($Delay) = ($Line =~ /delay=(.*), /);
         Stats::AddDelay($Delay);
         last SWITCH;
         };
      }
   }

1;
