#
#   Vispan - Virus and Spam analyser
#	This program analyses the mail log file entries created by the 
#	MailScanner program written by Julian Field. It is available at
#	http://www.mailscanner.info
#
#   Copyright (C) 2002  David While
#
#   $Id: ProcessLog.pm,v 1.5 2004/09/27 16:04:24 dwhile Exp $
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#   The author, David While, can be contacted by email at
#      david.while@uce.ac.uk
#   or by paper mail at
#      David While
#      School of Computing
#      University of Central England
#      Birmingham
#      B42 2SU
#      United Kingdom
#

package ProcessLog;
use HTTP::Date;
#use strict;

##################################################
#                                                #
# Subroutine: CreateTmpLog                       #
# Parameters: None                               #
# Returns: None                                  #
# Purpose: get the entries from the mail log     #
#          file from the last time we looked     #
#          until now                             #
#                                                #
##################################################
sub CreateTmpLog {
   my ($currpos, $ThisLine, $LogDate, $FilePos, $Date, $LastTime);
   my ($file);

   # Open the log file and find the entries writing them to the temporary
   # file
   $file = Config::Value(LogFile);
   open(LOG, $file);
   seek(LOG, 0, 2); $currpos = tell(LOG);
   if( $currpos < Stats::GetDate(FilePosition) ) {
      Stats::SetDate(FilePosition, 0);
      }
   seek(LOG,Stats::GetDate(FilePosition), 0);

   # Create the temporary file
   $file = Config::Value(tmpfile);
   if( !open(TMP, ">$file") ) {
      print "Temp file cannot be created. Please check the setting of tmpfile in your configuration file\n";
      $WorkDir = Config::Value(WorkDir);
      system("rm $WorkDir/mailstats.lck");
      exit 1;
      }
   $LastTime = time();
   while (defined($ThisLine = <LOG>)) {
      ($Date) = ($ThisLine =~ /^([A-Za-z0-9 :]{15})/);
      $LogDate = &ConvertDate($Date);
      if( Stats::GetDate(StartDate) == 0 ) {
         Stats::SetDate(StartDate, $LogDate);
         }
      if(( $LogDate - Stats::GetDate(LastUpdate) > 0) and
            ($LogDate <= $LastTime )) {
         print TMP $ThisLine;
         $FilePos = tell( LOG );
         }
   }
   Stats::SetDate(FilePosition, $FilePos);
   Stats::SetDate(LastUpdate, $LastTime);
   close (TMP);
   close (LOG);
}

##################################################
#                                                #
# Subroutine: ConvertDate                        #
# Parameters: Date                               #
# Returns: converted date                        #
# Purpose: Convert a date in ASCII format into   #
#          time format                           #
#                                                #
##################################################
sub ConvertDate {
   my ($Date) = @_;
   my ($NewTime);

   $NewTime = HTTP::Date::str2time($Date);
   return $NewTime;
}

1;
